<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage --><html lang="en">
<head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<!-- Generated by javadoc (1.8.0_121) on Thu Sep 26 20:37:32 UTC 2019 -->
<title>LocationDataSourceHERE (HERE Android Premium SDK)</title>
<meta name="date" content="2019-09-26">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
<meta name="copyright" content="© 2019 HERE Europe B.V."><meta name="html_title" content="HERE Android Premium SDK NLP Premium Edition v3.13 API Reference"><meta name="DC.Document.Id" content="28f10409-3c3a-4aab-a398-4c46acfeab3a"><meta name="DC.Document.Name" content="HERE Android Premium SDK Java API Reference"><meta name="DC.Product.Name" content="HERE Android Premium SDK"><meta name="DC.Product.Version" content="3.13"><meta name="DC.Creation.Date" content="2019-10-25T09:06:39+00:00"></head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="LocationDataSourceHERE (HERE Android Premium SDK)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":6,"i1":9,"i2":9,"i3":6,"i4":6,"i5":6};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/LocationDataSourceHERE.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../com/here/android/mpa/common/LocationDataSourceDevice.html" title="class in com.here.android.mpa.common"><span class="typeNameLink">Prev Class</span></a></li>
<li><a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.IndoorPositioningMode.html" title="enum in com.here.android.mpa.common"><span class="typeNameLink">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?com/here/android/mpa/common/LocationDataSourceHERE.html" target="_top">Frames</a></li>
<li><a href="LocationDataSourceHERE.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary: </li>
<li><a href="#nested.class.summary">Nested</a> | </li>
<li>Field | </li>
<li><a href="#constructor.summary">Constr</a> | </li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail: </li>
<li>Field | </li>
<li><a href="#constructor.detail">Constr</a> | </li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">com.here.android.mpa.common</div>
<h2 title="Class LocationDataSourceHERE" class="title">Class LocationDataSourceHERE</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li><a href="../../../../../com/here/android/mpa/common/LocationDataSource.html" title="class in com.here.android.mpa.common">com.here.android.mpa.common.LocationDataSource</a></li>
<li>
<ul class="inheritance">
<li>com.here.android.mpa.common.LocationDataSourceHERE</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public abstract class <span class="typeNameLabel">LocationDataSourceHERE</span>
extends <a href="../../../../../com/here/android/mpa/common/LocationDataSource.html" title="class in com.here.android.mpa.common">LocationDataSource</a></pre>
<div class="block">Abstract class that defines the interface for providing positions updates
 from a HERE hybrid location data source. Instance of this class can be
 created with <code>getInstance(StatusListener)</code> call.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="nested.class.summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Nested Class Summary table, listing nested classes, and an explanation">
<caption><span>Nested Classes</span><span class="tabEnd"> </span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Class and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static class </code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.IndoorPositioningMode.html" title="enum in com.here.android.mpa.common">LocationDataSourceHERE.IndoorPositioningMode</a></span></code>
<div class="block">Defines supported indoor positioning modes.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static class </code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.IndoorPositioningModeSetResult.html" title="enum in com.here.android.mpa.common">LocationDataSourceHERE.IndoorPositioningModeSetResult</a></span></code>
<div class="block">Defines result codes for indoor positioning mode set call.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd"> </span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.html#LocationDataSourceHERE--">LocationDataSourceHERE</a></span>()</code> </td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd"> </span></span><span id="t1" class="tableTab"><span><a href="javascript:show(1);">Static Methods</a></span><span class="tabEnd"> </span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd"> </span></span><span id="t3" class="tableTab"><span><a href="javascript:show(4);">Abstract Methods</a></span><span class="tabEnd"> </span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd"> </span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>abstract <a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.IndoorPositioningMode.html" title="enum in com.here.android.mpa.common">LocationDataSourceHERE.IndoorPositioningMode</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.html#getIndoorPositioningMode--">getIndoorPositioningMode</a></span>()</code>
<div class="block">Get active indoor positioning mode.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>static <a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.html" title="class in com.here.android.mpa.common">LocationDataSourceHERE</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.html#getInstance--">getInstance</a></span>()</code>
<div class="block">Get access to the LocationDataSourceHERE Singleton.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>static <a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.html" title="class in com.here.android.mpa.common">LocationDataSourceHERE</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.html#getInstance-com.here.android.positioning.StatusListener-">getInstance</a></span>(<a href="../../../../../com/here/android/positioning/StatusListener.html" title="interface in com.here.android.positioning">StatusListener</a> statusListener)</code>
<div class="block">Get access to the LocationDataSourceHERE Singleton.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>abstract <a href="../../../../../com/here/android/positioning/radiomap/RadioMapLoader.html" title="interface in com.here.android.positioning.radiomap">RadioMapLoader</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.html#getRadioMapLoader--">getRadioMapLoader</a></span>()</code>
<div class="block">Get instance of positioning radio map loader.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>abstract void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.html#setDiagnosticsListener-com.here.android.positioning.DiagnosticsListener-">setDiagnosticsListener</a></span>(<a href="../../../../../com/here/android/positioning/DiagnosticsListener.html" title="interface in com.here.android.positioning">DiagnosticsListener</a> listener)</code>
<div class="block">Register HERE positioning diagnostics listener instance for receiving
 positioning related events.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>abstract <a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.IndoorPositioningModeSetResult.html" title="enum in com.here.android.mpa.common">LocationDataSourceHERE.IndoorPositioningModeSetResult</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.html#setIndoorPositioningMode-com.here.android.mpa.common.LocationDataSourceHERE.IndoorPositioningMode-">setIndoorPositioningMode</a></span>(<a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.IndoorPositioningMode.html" title="enum in com.here.android.mpa.common">LocationDataSourceHERE.IndoorPositioningMode</a> mode)</code>
<div class="block">Set indoor positioning mode.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.com.here.android.mpa.common.LocationDataSource">
<!--   -->
</a>
<h3>Methods inherited from class com.here.android.mpa.common.<a href="../../../../../com/here/android/mpa/common/LocationDataSource.html" title="class in com.here.android.mpa.common">LocationDataSource</a></h3>
<code><a href="../../../../../com/here/android/mpa/common/LocationDataSource.html#getGpsStatus--">getGpsStatus</a>, <a href="../../../../../com/here/android/mpa/common/LocationDataSource.html#getIndoorStatus--">getIndoorStatus</a>, <a href="../../../../../com/here/android/mpa/common/LocationDataSource.html#getLastKnownLocation--">getLastKnownLocation</a>, <a href="../../../../../com/here/android/mpa/common/LocationDataSource.html#getNetworkStatus--">getNetworkStatus</a>, <a href="../../../../../com/here/android/mpa/common/LocationDataSource.html#isValidForMapMatching-com.here.android.mpa.common.PositioningManager.LocationMethod-android.location.Location-">isValidForMapMatching</a>, <a href="../../../../../com/here/android/mpa/common/LocationDataSource.html#onLocationUpdated-com.here.android.mpa.common.PositioningManager.LocationMethod-android.location.Location-">onLocationUpdated</a>, <a href="../../../../../com/here/android/mpa/common/LocationDataSource.html#onStatusUpdated-com.here.android.mpa.common.PositioningManager.LocationMethod-int-">onStatusUpdated</a>, <a href="../../../../../com/here/android/mpa/common/LocationDataSource.html#start-com.here.android.mpa.common.PositioningManager.LocationMethod-">start</a>, <a href="../../../../../com/here/android/mpa/common/LocationDataSource.html#stop--">stop</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="LocationDataSourceHERE--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>LocationDataSourceHERE</h4>
<pre>public LocationDataSourceHERE()</pre>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getInstance--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getInstance</h4>
<pre>public static <a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.html" title="class in com.here.android.mpa.common">LocationDataSourceHERE</a> getInstance()</pre>
<div class="block">Get access to the LocationDataSourceHERE Singleton. MapsEngine has to be successfully
 initialized before the call.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>LocationDataSourceHERE instance</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.security.AccessControlException</code> - if HERE positioning is not licensed.</dd>
</dl>
</li>
</ul>
<a name="getInstance-com.here.android.positioning.StatusListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getInstance</h4>
<pre>public static <a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.html" title="class in com.here.android.mpa.common">LocationDataSourceHERE</a> getInstance(<a href="../../../../../com/here/android/positioning/StatusListener.html" title="interface in com.here.android.positioning">StatusListener</a> statusListener)</pre>
<div class="block">Get access to the LocationDataSourceHERE Singleton. MapsEngine has to be successfully
 initialized before the call.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>statusListener</code> - Status listener instance for retrieving HERE positioning related
                       events.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>LocationDataSourceHERE instance</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.security.AccessControlException</code> - if HERE positioning has not been licensed.</dd>
</dl>
</li>
</ul>
<a name="setIndoorPositioningMode-com.here.android.mpa.common.LocationDataSourceHERE.IndoorPositioningMode-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setIndoorPositioningMode</h4>
<pre>public abstract <a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.IndoorPositioningModeSetResult.html" title="enum in com.here.android.mpa.common">LocationDataSourceHERE.IndoorPositioningModeSetResult</a> setIndoorPositioningMode(<a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.IndoorPositioningMode.html" title="enum in com.here.android.mpa.common">LocationDataSourceHERE.IndoorPositioningMode</a> mode)</pre>
<div class="block">Set indoor positioning mode. Mode defines which radio maps HERE
 positioning is allowed to use.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>mode</code> - New indoor positioning mode.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Result for the mode change.</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.IndoorPositioningMode.html" title="enum in com.here.android.mpa.common"><code>LocationDataSourceHERE.IndoorPositioningMode</code></a></dd>
</dl>
</li>
</ul>
<a name="getIndoorPositioningMode--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getIndoorPositioningMode</h4>
<pre>public abstract <a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.IndoorPositioningMode.html" title="enum in com.here.android.mpa.common">LocationDataSourceHERE.IndoorPositioningMode</a> getIndoorPositioningMode()</pre>
<div class="block">Get active indoor positioning mode.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Current indoor positioning mode.</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.IndoorPositioningMode.html" title="enum in com.here.android.mpa.common"><code>LocationDataSourceHERE.IndoorPositioningMode</code></a></dd>
</dl>
</li>
</ul>
<a name="getRadioMapLoader--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getRadioMapLoader</h4>
<pre>public abstract <a href="../../../../../com/here/android/positioning/radiomap/RadioMapLoader.html" title="interface in com.here.android.positioning.radiomap">RadioMapLoader</a> getRadioMapLoader()</pre>
<div class="block">Get instance of positioning radio map loader. Radio map loader can be
 used for downloading positioning radio maps for specified areas.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Radio map loader instance.</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.security.AccessControlException</code> - if positioning radio map downloading API has
 not been licensed.</dd>
</dl>
</li>
</ul>
<a name="setDiagnosticsListener-com.here.android.positioning.DiagnosticsListener-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>setDiagnosticsListener</h4>
<pre>public abstract void setDiagnosticsListener(<a href="../../../../../com/here/android/positioning/DiagnosticsListener.html" title="interface in com.here.android.positioning">DiagnosticsListener</a> listener)</pre>
<div class="block">Register HERE positioning diagnostics listener instance for receiving
 positioning related events. Only one listener can be registered at a
 time. To unregister the existing listener, set <code>listener</code> to
 <code>null</code>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>listener</code> - The Diagnostics listener instance for which HERE positioning
 related events should be delivered or null if you are no longer interested
 in diagnostic events.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/LocationDataSourceHERE.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
<div class="aboutLanguage">Copyright (c) 2011-2019 HERE Global B.V. All rights reserved.</div>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../com/here/android/mpa/common/LocationDataSourceDevice.html" title="class in com.here.android.mpa.common"><span class="typeNameLink">Prev Class</span></a></li>
<li><a href="../../../../../com/here/android/mpa/common/LocationDataSourceHERE.IndoorPositioningMode.html" title="enum in com.here.android.mpa.common"><span class="typeNameLink">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?com/here/android/mpa/common/LocationDataSourceHERE.html" target="_top">Frames</a></li>
<li><a href="LocationDataSourceHERE.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary: </li>
<li><a href="#nested.class.summary">Nested</a> | </li>
<li>Field | </li>
<li><a href="#constructor.summary">Constr</a> | </li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail: </li>
<li>Field | </li>
<li><a href="#constructor.detail">Constr</a> | </li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
